-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Matt Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: 20 bit Adder/Substractor
--Date			: Dec 6th, 2000
--Note			: SEL = 0 => ADDITION
--				: SEL = 1 => SUBSTRACTION
-------------------------------------------------------------
-------------------------------------------------------------

Library IEEE;
use IEEE.std_logic_1164.all;

entity FA is 
	port(	a, b, cin: in  std_logic;
        	cout, sum: out std_logic );
end FA;

architecture heart_FA of FA is
	signal s0, s1, s2, s3: std_logic;
begin
	s0 <= a and b  ;
	s1 <= a and cin;
	s2 <= b and cin;
    cout <= s0 or s1 or s2;

	s3 <= a  xor b  ;
	sum<= s3 xor cin;
end heart_FA; 


Library IEEE;
Use IEEE.std_logic_1164.all;

ENTITY ADDSUB IS
	PORT(	a, b: IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
			sum : OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
			sel : IN  STD_LOGIC		      ;
			ovf, cout: OUT STD_LOGIC		);
END ADDSUB;

ARCHITECTURE STRUCT OF ADDSUB IS

	COMPONENT FA  
	PORT(	a, b, cin: in  std_logic;
        	cout, sum: out std_logic );
	end COMPONENT;
	
	COMPONENT mux20 
	PORT ( 	A, B  	:in  std_logic_vector (19 downto 0);
			sel_line:in  std_logic					   ;
			output	:out std_logic_vector (19 downto 0) );
	end COMPONENT;
	
	SIGNAL	sc, sb, sb_not : STD_LOGIC_VECTOR(19 DOWNTO 0);
BEGIN
	sb_not<= NOT b; 

	muxti : mux20 PORT MAP(b, sb_not, sel, sb);
	
	fa0  : FA port map(a(0 ), sb(0 ), sel    , sc(0 ), sum(0 ));
	fa1  : FA port map(a(1 ), sb(1 ), sc(0 ) , sc(1 ), sum(1 ));
	fa2  : FA port map(a(2 ), sb(2 ), sc(1 ) , sc(2 ), sum(2 ));
	fa3  : FA port map(a(3 ), sb(3 ), sc(2 ) , sc(3 ), sum(3 ));
	fa4  : FA port map(a(4 ), sb(4 ), sc(3 ) , sc(4 ), sum(4 ));
	fa5  : FA port map(a(5 ), sb(5 ), sc(4 ) , sc(5 ), sum(5 ));
	fa6  : FA port map(a(6 ), sb(6 ), sc(5 ) , sc(6 ), sum(6 ));
	fa7  : FA port map(a(7 ), sb(7 ), sc(6 ) , sc(7 ), sum(7 ));
	fa8  : FA port map(a(8 ), sb(8 ), sc(7 ) , sc(8 ), sum(8 ));
	fa9  : FA port map(a(9 ), sb(9 ), sc(8 ) , sc(9 ), sum(9 ));
	fa10 : FA port map(a(10), sb(10), sc(9 ) , sc(10), sum(10));
	fa11 : FA port map(a(11), sb(11), sc(10) , sc(11), sum(11));
	fa12 : FA port map(a(12), sb(12), sc(11) , sc(12), sum(12));
	fa13 : FA port map(a(13), sb(13), sc(12) , sc(13), sum(13));
	fa14 : FA port map(a(14), sb(14), sc(13) , sc(14), sum(14));
	fa15 : FA port map(a(15), sb(15), sc(14) , sc(15), sum(15));
	fa16 : FA port map(a(16), sb(16), sc(15) , sc(16), sum(16));
	fa17 : FA port map(a(17), sb(17), sc(16) , sc(17), sum(17));
	fa18 : FA port map(a(18), sb(18), sc(17) , sc(18), sum(18));
	fa19 : FA port map(a(19), sb(19), sc(18) , sc(19), sum(19));

	cout <= sc(19);
	ovf  <= sc(19) XOR sc(18);
END STRUCT;	