 LIBRARY IEEE;
 USE IEEE.std_logic_1164.ALL;
 
 entity BarLevel is
 	port(clk,rst: in std_logic;
 	     Volume: in std_logic_vector(19 downto 0);
 	     Bar: out std_logic_vector(7 downto 0)
 	     );
 end BarLevel;
 
 architecture behavioral of BarLevel is
 
 signal sBar: std_logic_vector(7 downto 0);
 
 begin
 
Bar <= sBar; 
 
 Process(clk)
 	
 	begin
 	
 	if( rst = '1' ) then
 		sBar <= "11111111";
 	elsif (rising_edge(clk)) then
 		if ( Volume = x"00000" ) then
 			sBar <= "11111111";
 		elsif ((Volume > x"1FFFF") and (Volume < x"28FFF")) then
 			sBar <= "11111110";
 		elsif ((Volume > x"28FFF") and (Volume < x"31FFF")) then
 			sBar <= "11111100";
 		elsif ((Volume > x"31FFF") and (Volume < x"3AFFF")) then
 			sBar <= "11111000";
 		elsif ((Volume > x"3AFFF") and (Volume < x"43FFF")) then
 			sBar <= "11110000";
 		elsif ((Volume > x"43FFF") and (Volume < x"4CFFF")) then
 			sBar <= "11100000";
 		elsif ((Volume > x"4CFFF") and (Volume < x"55FFF")) then
 			sBar <= "11000000";
 		elsif ((Volume > x"55FFF") and (Volume < x"5EFFF")) then
 			sBar <= "10000000";
 		elsif ((Volume > x"5EFFF") and (Volume < x"67FFF")) then
 			sBar <= "00000000";
 		else
 			sBar <= "11111111";
 		end if;
 	end if;
 	
 	end process;
 end behavioral;
 		
