-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Math Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: Control For GetMinMax
--Date			: Dec 6th, 2000	  
-------------------------------------------------------------
-------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY contr_minmax IS
	PORT(	req   : IN  STD_LOGIC;
		cw    : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
		sw    : IN  STD_LOGIC;
		clk, reset: IN STD_LOGIC
	);
END contr_minmax;

ARCHITECTURE beha OF contr_minmax IS
	TYPE statetype IS (WaitReq, LTemp, Cmp, LPrevDec, LPrevInc, 
		  	WaitReqnDec, WaitReqDec, LTempDec, CmpDec, LMin,
		  	WaitReqnInc, WaitReqInc, LTempInc, CmpInc, LMax);
	SIGNAL state: statetype; 
		  	

BEGIN
	PROCESS( clk, reset )
	BEGIN
		IF(reset = '1') THEN state <= WaitReq;
				    	cw <= "00000";
		ELSIF(clk'event AND clk = '1') THEN 
			CASE state is
			WHEN WaitReq => IF(req = '1')THEN
					state <= LTemp;
					cw    <= "10000";
					ELSIF(req = '0')THEN
					state <= WaitReq;
					cw    <= "00000";
					END IF;
			WHEN LTemp   => state <= Cmp;
					cw    <= "00000";
			WHEN Cmp     => IF(sw='1')THEN
					state <= LPrevDec;
					cw    <= "01000";
					ELSE 
					state <= LPrevInc;
					cw    <= "01000";
					END IF;
	--now we are in Decreasing states
	--as soon as we see the value in temp greater than value in prev, 
	--we get minimum value.				
			WHEN LPrevDec=> state <= WaitReqnDec;
					cw    <= "00000";
			WHEN WaitReqnDec=>
					IF(req = '1')THEN
					state <= WaitReqnDec;
					cw    <= "00000";
					ELSE
					state <= WaitReqDec;
					cw    <= "00000";
					END IF;
			WHEN WaitReqDec=>
					IF(req = '0')THEN
					state <= WaitReqDec;
					cw    <= "00000";
					ELSE
					state <= LTempDec;
					cw    <= "10000";
					END IF;
			WHEN LTempDec=> state <= CmpDec;
					cw    <= "00000";
			WHEN CmpDec  => IF(sw = '1')THEN 
					state <= LPrevDec;
					cw    <= "01000";
					ELSE 
					state <= LMin;
					cw    <= "00101";
					END IF;
			WHEN LMin    => state <= LPrevInc;
					cw    <= "01000";
	--now we are in Increasing states.
	--as soon as we see the value in temp less than the value in prev
	--we get maximum value				
			WHEN LPrevInc=> state <= WaitReqnInc;
					cw    <= "00000";
			WHEN WaitReqnInc=>
					IF(req = '1')THEN
					state <= WaitReqnInc;
					cw    <= "00000";
					ELSE
					state <= WaitReqInc;
					cw    <= "00000";
					END IF;
			WHEN WaitReqInc=>
					IF(req = '0')THEN
					state <= WaitReqInc;
					cw    <= "00000";
					ELSE
					state <= LTempInc;
					cw    <= "10000";
					END IF;	
			WHEN LTempInc=> state <= CmpInc;
					cw    <= "00000";
			WHEN CmpInc  => IF(sw = '0')THEN 
					state <= LPrevInc;
					cw    <= "01000";
					ELSE 
					state <= LMax;
					cw    <= "00011";
					END IF;
			WHEN LMax    => state <= LPrevDec;
					cw    <= "01000";	
			WHEN OTHERS  => NULL;		
			END CASE;
		END IF;
	END PROCESS;
END beha;
