-------------------------------------------------------------
-------------------------------------------------------------
--Name 			: Matt Smith, Ronald Koss, and Chan Min
--Instructor	: Dr. Coulston
--Course		: CENBD 497A
--Assignment	: Codec Analysis 
--		: (Get the amplitude of sin wave that goes into 
--		: the Codec on the Xess Board)
--Date			: Dec 6th, 2000	  
-------------------------------------------------------------
-------------------------------------------------------------


LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY FindVol IS
	PORT(	clk : IN STD_LOGIC;		
		reset: IN STD_LOGIC;		
		Rin,Lin: in std_logic_vector(19 downto 0);
		Rready,Lready: in std_logic;
		result_L, result_R:OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		complete: out std_logic		
	);
END FindVol;

ARCHITECTURE structural OF FindVol IS

COMPONENT GetMinMax 
	PORT(	req   : IN  STD_LOGIC;
		done  : OUT STD_LOGIC;
		data  : IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
		min, max: OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		clk, reset: IN STD_LOGIC
	);
END COMPONENT;

COMPONENT GetDifference 
	PORT(	min, max : IN  STD_LOGIC_VECTOR(19 DOWNTO 0);
		result   : OUT STD_LOGIC_VECTOR(19 DOWNTO 0);
		enable	 : IN  STD_LOGIC;
		clk,reset: IN STD_LOGIC
	);
END COMPONENT;


SIGNAL smin_L, smax_L, smin_R, smax_R: STD_LOGIC_VECTOR(19 DOWNTO 0); 
SIGNAL sdone_L, sdone_R : STD_LOGIC;

BEGIN	
	getminmaxL: GetMinMax PORT MAP(Lready, sdone_L, Lin, smin_L, smax_L, clk, reset);
	getminmaxR: GetMinMax PORT MAP(Rready, sdone_R, Rin, smin_R, smax_R, clk, reset);
		
	getdiffL: GetDifference PORT MAP(smin_L, smax_L, result_L, sdone_L, clk, reset);
	getdiffR: GetDifference PORT MAP(smin_R, smax_R, result_R, sdone_R, clk, reset);	
	complete <= sdone_L or sdone_R;

END structural;
